models/Formulario1.php
<?php

namespace app\models;

use yii\base\Model;


class Formulario1 extends Model{
    public $numero1;
    public $numero2;
    
    public function rules() {
        return [
            [["numero1", "numero2"],'required'],
            [["numero1", "numero2"], 'integer', "max" => 100],
        ];
    }
    
    public function Suma(){
        return $this->numero1+$this->numero2;
    }
    
    public function Producto() {
        return $this->numero1*$this->numero2;
    }
    
    public function resultados() {
        return [
            "suma" => $this->Suma(),
            "producto" => $this->Producto(),
        ];
    }
}

models/Formulario2.php
<?php

namespace app\models;

use yii\base\Model;

class Formulario2 extends Model{
    public $texto;
    
    public function rules() {
        return [
            ["texto", 'required']
        ];               
    }
    
    public function caracteres() {
        
        return strlen($this->texto);
    }
    
    // Relacion entre el titulo de la propiedad (label) y el nombre de la propiedad
    public function attributeLabels(): array {
        
        return [
            "texto" => "Introduce un texto",
        ];
    }


    
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller {

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        return $this->render('index');
    }

    public function actionEjerrepaso1() {
        // llamar a una vista que me muestre un par de imagenes
        $fotos = [
            'f1.jpg', 'f2.jpg'
        ];

        return $this->render('fotos', [
                    'fotos' => $fotos,
        ]);
    }

    public function actionEjerrepaso2() {
        // llamar a una vista que me muestre titulo y contenido
        $datos = [
            "titulo" => "Ejemplo de datos en MVC",
            "contenido" => "Este contenido se lo pasa el controlador a la vista"
        ];

        return $this->render('texto', [
                    "titulo" => $datos['titulo'],
                    "contenido" => $datos['contenido'],
        ]);
    }

    public function actionEjerform1() {
        
        // crear un objeto con el modelo Formulario1
        $model = new \app\models\Formulario1();

        // al if entra si has pulsado enviar
        if ($model->load(Yii::$app->request->post())) { // cargar los datos del formulario en el modelo
            if ($model->validate()) { // comprobar las reglas del modelo
                            
                return $this->render('resultados',[
                    "model" => $model,
                ]);
            }
        }

        // carga el formulario vacio o con errores de validacion
        return $this->render('formulario1', [
                    'model' => $model,
        ]);
    }

    public function actionEjerform2() {
        // cargar un formulario que me pida un texto
        // cuando escriba el texto y pulse enviar me indica el numero de caracteres del texto
        // 1- crear modelo Formulario2
        // 2- ir a gii y crear formulario2 vista
        // 3- copiar accion del controlador
        // 4- pegar la accion
        // 5- crear en el modelo un metodo publico que retorne la longitud del texto
        // 6- añadir en la accion la vista que muestra resultado(resultados2) y pasarle el modelo
        
        $model = new \app\models\Formulario2();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                
                return $this->render("resultado2",[
                    'model' => $model,
                ]);
            }
        }

        return $this->render('formulario2', [
            'model' => $model,
        ]);

    }

}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Ejercicios de Repaso', 'items' =>[
                ['label' => 'Ejercico 1', 'url' => ['site/ejerrepaso1']],
                ['label' => 'Ejercico 2', 'url' => ['site/ejerrepaso2']],
            ]],
            ['label' => 'Ejercicios con Formularios', 'items' =>[
                ['label' => 'Ejercico 1', 'url' => ['site/ejerform1']],
                ['label' => 'Ejercico 2', 'url' => ['site/ejerform2']],                
            ]],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/formulario1.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Formulario1 */
/* @var $form ActiveForm */
?>
<div class="site-formulario1">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'numero1') ?>
        <?= $form->field($model, 'numero2') ?>
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario1 -->

views/site/formulario2.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Formulario2 */
/* @var $form ActiveForm */
?>
<div class="site-formulario2">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'texto') ?>
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario2 -->

views/site/fotos.php
<?php

use yii\helpers\Html;
    
foreach ($fotos as $value){
    echo Html::img("@web/imgs/$value",[
        "alt" => "imagen",
        "class" => "imagen"
    ]);
}

?>

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Ejemplo 2';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Formularios y repaso</h1>

        <p class="lead">Ejercicios con formularios y modelos</p>
        
    </div>
</div>

views/site/resultado2.php
<div>
    <p>El texto introducido "<?= $model->texto; ?>" contiene <?= $model->caracteres() ?> caracteres</p>
</div>

views/site/resultados.php
<ul>
<?php

foreach ($model->resultados() as $indice => $valor){
    echo "<li>{$indice}: {$valor}</li>";
}

?>
</ul>

views/site/texto.php
<?php
    use yii\helpers\Html;
?>

<h1><?= $titulo ?></h1>
<div>
    <p><?= $contenido ?></p>
</div>

<div>
<?php
    echo Html::tag("p", $contenido);
?>
</div>